VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "VB5 Printerbug Workaround"
   ClientHeight    =   2625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3255
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2625
   ScaleWidth      =   3255
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdExit 
      Caption         =   "Beenden"
      Height          =   390
      Left            =   1905
      TabIndex        =   3
      Top             =   2160
      Width           =   1275
   End
   Begin VB.ListBox List1 
      Height          =   1815
      Left            =   60
      TabIndex        =   1
      Top             =   270
      Width           =   3135
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Als Standarddrucker"
      Height          =   390
      Left            =   60
      TabIndex        =   0
      Top             =   2160
      Width           =   1770
   End
   Begin VB.Label Label1 
      Caption         =   "Verfgbare Drucker:"
      Height          =   270
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   2445
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Win95SetDefaultPrinter()
Dim Handle As Long          'handle to printer
Dim PrinterName As String
Dim pd As PRINTER_DEFAULTS
Dim x As Long
Dim need As Long            ' bytes needed
Dim pi5 As PRINTER_INFO_5   ' your PRINTER_INFO structure
Dim LastError As Long
' determine which printer was selected
PrinterName = List1.List(List1.ListIndex)
' none - exit
If PrinterName = "" Then Exit Sub
' set the PRINTER_DEFAULTS members
pd.pDatatype = 0&
pd.DesiredAccess = PRINTER_ALL_ACCESS
' Get a handle to the printer
x = OpenPrinter(PrinterName, Handle, pd)
If x = False Then Exit Sub

' Make an initial call to GetPrinter, requesting Level 5
' (PRINTER_INFO_5) information, to determine how many bytes
' you need
x = GetPrinter(Handle, 5, ByVal 0&, 0, need)
' don't want to check GetLastError here - it's supposed to fail
' with a 122 - ERROR_INSUFFICIENT_BUFFER
' redim t as large as you need
ReDim t((need \ 4)) As Long
' and call GetPrinter for keepers this time
x = GetPrinter(Handle, 5, t(0), need, need)
' failed the GetPrinter
If x = False Then Exit Sub

' set the members of the pi5 structure for use with SetPrinter.
' PtrCtoVbString copies the memory pointed at by the two string
' pointers contained in the t() array into a Visual Basic string.
' The other three elements are just DWORDS (long integers) and
' don't require any conversion
pi5.pPrinterName = PtrCtoVbString(t(0))
pi5.pPortName = PtrCtoVbString(t(1))
pi5.Attributes = t(2)
pi5.DeviceNotSelectedTimeout = t(3)
pi5.TransmissionRetryTimeout = t(4)

' this is the critical flag that makes it the default printer
pi5.Attributes = PRINTER_ATTRIBUTE_DEFAULT
' call SetPrinter to set it
x = SetPrinter(Handle, 5, pi5, 0)
' failed the SetPrinter
If x = False Then
    MsgBox "SetPrinterFailed. Error code: " & GetLastError()
    Exit Sub
End If
' and close the handle
ClosePrinter (Handle)
End Sub

Private Sub GetDriverAndPort(ByVal Buffer As String, DriverName As String, PrinterPort As String)
Dim iDriver As Integer
Dim iPort As Integer
DriverName = ""
PrinterPort = ""

'The driver name is first in the string terminated by a comma
iDriver = InStr(Buffer, ",")
If iDriver > 0 Then
'Strip out the driver name
DriverName = Left(Buffer, iDriver - 1)

'The port name is the second entry after the driver name
'separated by commas.
iPort = InStr(iDriver + 1, Buffer, ",")
If iPort > 0 Then
'Strip out the port name
PrinterPort = Mid(Buffer, iDriver + 1, iPort - iDriver - 1)
End If
End If
End Sub

Private Sub ParseList(lstCtl As Control, ByVal Buffer As String)
Dim i As Integer
Do
i = InStr(Buffer, Chr(0))
If i > 0 Then
lstCtl.AddItem Left(Buffer, i - 1)
Buffer = Mid(Buffer, i + 1)
Else
lstCtl.AddItem Buffer
Buffer = ""
End If
Loop While i > 0
End Sub
Private Sub WinNTSetDefaultPrinter()
Dim Buffer As String
Dim DeviceName As String
Dim DriverName As String
Dim PrinterPort As String
Dim PrinterName As String
Dim r As Long
If List1.ListIndex > -1 Then
    'Get the printer information for the currently selected
    'printer in the list. The information is taken from the
    'WIN.INI file.
    Buffer = Space(1024)
    PrinterName = List1.Text
    r = GetProfileString("PrinterPorts", PrinterName, "", Buffer, Len(Buffer))
    'Parse the driver name and port name out of the buffer
    GetDriverAndPort Buffer, DriverName, PrinterPort
    If DriverName <> "" And PrinterPort <> "" Then
        SetDefaultPrinter List1.Text, DriverName, PrinterPort
    End If
End If
End Sub

Private Sub cmdExit_Click()
End
End Sub

Private Sub Command1_Click()
Dim osinfo As OSVERSIONINFO
Dim retvalue As Integer

osinfo.dwOSVersionInfoSize = 148
osinfo.szCSDVersion = Space$(128)
retvalue = GetVersionExA(osinfo)

If osinfo.dwPlatformId = 2 Then 'NT = 2
    Call WinNTSetDefaultPrinter
ElseIf osinfo.dwPlatformId = 1 Then 'Win95 = 1
    Call Win95SetDefaultPrinter
End If

'Der folgende Code ist original Microsoft
'  (ohne Bercksichtigung von Win95 B)!
'*******************************************
'If osinfo.dwMajorVersion = 3 And osinfo.dwMinorVersion = 51 And _
'osinfo.dwBuildNumber = 1057 And osinfo.dwPlatformId = 2 Then
'    Call WinNTSetDefaultPrinter
'ElseIf osinfo.dwMajorVersion = 4 And osinfo.dwMinorVersion = 0 _
' And osinfo.dwBuildNumber = 67109814 And osinfo.dwPlatformId = 1 Then
'    Call Win95SetDefaultPrinter
'ElseIf osinfo.dwMajorVersion = 4 And osinfo.dwMinorVersion = 0 _
' And osinfo.dwBuildNumber = 1381 And osinfo.dwPlatformId = 2 Then
'    Call WinNTSetDefaultPrinter
'End If
End Sub

Private Function PtrCtoVbString(Add As Long) As String
Dim sTemp As String * 512, x As Long
x = lstrcpy(sTemp, Add)
If (InStr(1, sTemp, Chr(0)) = 0) Then
PtrCtoVbString = ""
Else
PtrCtoVbString = Left(sTemp, InStr(1, sTemp, Chr(0)) - 1)
End If
End Function

Private Sub SetDefaultPrinter(ByVal PrinterName As String, _
ByVal DriverName As String, ByVal PrinterPort As String)
Dim DeviceLine As String
Dim r As Long
Dim l As Long
DeviceLine = PrinterName & "," & DriverName & "," & PrinterPort
' Store the new printer information in the [WINDOWS] section of
' the WIN.INI file for the DEVICE= item
r = WriteProfileString("windows", "Device", DeviceLine)
' Cause all applications to reload the INI file:
l = SendMessage(HWND_BROADCAST, WM_WININICHANGE, 0, "windows")
End Sub

Private Sub Form_Load()
Dim r As Long
Dim Buffer As String

'Get the list of available printers from WIN.INI
Buffer = Space(8192)
r = GetProfileString("PrinterPorts", vbNullString, "", Buffer, Len(Buffer))
'Display the list of printer in the list box List1
ParseList List1, Buffer
End Sub


